/*************************************************************************
MGLApp.h

Main application class.

Author   :   Dave Astle

Written for More OpenGL Game Programming
*************************************************************************/

#ifndef MGLAPP_H_INCLUDED
#define MGLAPP_H_INCLUDED

#ifdef WIN32
  #define WIN32_LEAN_AND_MEAN
  #define WIN32_EXTRA_LEAN
  #include <windows.h>
#endif

#include "../../_common/glee.h"
#include <gl/glu.h>

#include "Skybox.h"
#include "CSimpCamera.h"

// values used to set up the window and rendering context
const char MGL_APP_NAME[]	= "MOGLGP - Chapter 1 - Occlusion Queries";

const int MGL_WINDOW_WIDTH = 800;
const int MGL_WINDOW_HEIGHT = 600;

const int MGL_COLOR_BITS = 32;
const int MGL_DEPTH_BITS = 24;
const int MGL_STENCIL_BITS = 0;

const bool MGL_FORCE_FULLSCREEN = true;


class MGLApp
{
public:
	MGLApp();
	virtual ~MGLApp();

	bool Init();
	bool Shutdown();
	void SetupProjection( int width, int height );
	void Update( double dt );
	void Render();
  void ProcessMouseInput(int deltaX, int deltaY);

private:
  GLfloat DrawSun();

  int m_windowWidth;
  int m_windowHeight;

  CSkybox m_skybox;
  GLfloat m_brightness;
  CSimpCamera m_camera;
  GLuint m_query;
};

#endif // MGLAPP_H_INCLUDED