#include "sdl.h"
#include <stdlib.h>

#include "CGfxOpenGL.h"

long windowWidth = 800;
long windowHeight = 600;
long windowBits = 32;

void SetGLAttributes()
{
  SDL_GL_SetAttribute(SDL_GL_BUFFER_SIZE, 32);
  SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 24);
  SDL_GL_SetAttribute(SDL_GL_STENCIL_SIZE, 8);
  SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
  SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 1);
  SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, 6);
}

int main(int argc, char* argv[])
{
  SDL_Init(SDL_INIT_VIDEO);
  atexit(SDL_Quit);

  SetGLAttributes();

  SDL_Surface* pDisplay = SDL_SetVideoMode(windowWidth, windowHeight, windowBits, SDL_OPENGL);

  if (pDisplay == NULL)
  {
    fprintf(stderr, "Couldn't set GL mode: %s\n", SDL_GetError());
    exit(0);
  }

  CGfxOpenGL* glRender = new CGfxOpenGL();
  glRender->Init();
  glRender->SetupProjection(windowWidth, windowHeight);

  for (;;)
  {
    SDL_Event event;

    if (SDL_PollEvent(&event) == 0)
    {
      glRender->Prepare(0);
      glRender->Render();
      SDL_GL_SwapBuffers();
    }
    else
    {
      if (SDL_QUIT == event.type)
        break;
    }
  }
  glRender->Shutdown();
  delete glRender;

  return 0;
}